*-------------------------------------------------------------------------*
 * MINIGUI - Harbour Win32 GUI library Demo
 * Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
 * Original Proyect by brain 2016 Modifications Mustafa Lpez 2018
 * http://www.hmgforum.com/viewtopic.php?f=14&t=4862&hilit=brain
*-------------------------------------------------------------------------*

*------------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*------------------------------------------*

#include "hmg.ch"
#include "dbstruct.ch"
#include "hmg_BoxLetterShow.ch"
#include "Apoyo.prg"
#include "mPrint.prg"
#include "WebCam.Prg"
#include "NumCounter.prg"
*--------------------------------------------*

FUNCTION Main()

  REQUEST DBFCDX , DBFFPT
  RDDSETDEFAULT( "DBFCDX" )

  REQUEST HB_LANG_ESWIN
  REQUEST HB_CODEPAGE_ESWIN
  HB_CDPSELECT('ESWIN')
  HB_LANGSELECT('ESWIN')

*------------------------------------------------------------------*

  SET CODEPAGE TO SPANISH
  SET LANGUAGE TO SPANISH
  SET EXCLUSIVE ON   //OFF
  SET CENTURY ON
  SET DATE FRENCH
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET EPOCH TO 2000
  SET ESCAPE ON
  SET DELETED ON
  SET NAVIGATION EXTENDED
  SET SOFTSEEK ON  
  SET DECIMALS TO 0
  SET TOOLTIPSTYLE BALLOON

*-------------------------------------------------------------------*
*-------------------------------------------------------------------*
  Public aTable, ficher, Xnew_RecNo , cMatch , cMatch1 , cMatch2 
*-------------------------------------------------------------------*
  Public nOrder:= 0
  Public nOrderX
  Public lExistRecords := .T.
  Public Nuevo
  Public hBitmap
*-------------------------------------------------------------------*
  nOrder := 1
  SAVE TO control.mem ALL LIKE nOrder*
*-------------------------------------------------------------------*
 IF ! File("Photo_Num.mem")
      Nuevo := "00000"
      SAVE TO Photo_Num ALL LIKE Nuevo
 ENDIF
*-------------------------------------------------------------------*
    CLOSE DATABASES
    SELECT 1 
    USE TEST via "DBFCDX" New   
    DELETE FOR test->code <= 0
    PACK
    LOCATE FOR test->PHOTO <= SPACE(1)  
    IF FOUND()
       REPLACE test->PHOTO  WITH "Photo\00000.jpg"      
    ENDIF
    dbGotop()
*-------------------------------------------------------------------*
*-------------------------------------------------------------------*

  DEFINE WINDOW Form_1            ;
      AT 0,0                      ;
      WIDTH  1125                 ;
      HEIGHT 725                  ; 
      TITLE ""                    ;
      ICON 'Logo'                 ;
      BACKCOLOR { 031,154,108 }   ;
      NOMAXIMIZE NOSYSMENU NOSIZE ;
      MAIN                        ;
      ON INIT DateBien()          ;
      ON RELEASE CloseTable()
      ON KEY ESCAPE ACTION FinalProgram()

      DEFINE TIMER Timer_1abQ ;
              INTERVAL 100 ;
              ACTION { || thisWindow.Row := 003, thisWindow.Col := 110 }    
 
      DEFINE TIMER Timer_1Q INTERVAL 1000  ACTION (RELEASE MEMORY)

*----------------------  Routine TIMER donated by Lucho Miranda  ElSalnes@telefonica.net ---------------------------*
          DEFINE TIMER Timer_1 INTERVAL 1000 ACTION ;
                    ( Form_1.Title :="DataBase WebCam Photo"+ SPACE(03)+" Date: " + DTOC(DATE()) + ;
                     SPACE(03) + "Time: " + TIME() )
*-------------------------------------------------------------------------------------------------------------------*
*------------------------------------------  Letra Titulo ----------------------------------------------------------*
     LetterShadow (014, 264 ,"01hi","02hi","DataBase WebCam Photo","Snap ITC",24,.T.,.T., 000,000,000, 255,234,000 )
*-------------------------------------------  End Titulo -----------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------* 

     NewBoxShadow( 079, 042, 678, 174 ,"05hiq" ,"06hiq","07hiq", .T. , .F. , .T. , 016,000,100 , 128,126,255 )  

                      Form_1.Label_05hiq.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)
                      Form_1.Label_06hiq.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)
                      Form_1.Label_07hiq.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)
*-------------------------------------------------------------------------------------------------------------------*
 
     Box( 079 , 041 , 670 , 164, "08hiq", 253, 209, 209  )   // <-----   Box Undido ----> BORDER CLIENTEDGE     

                      Form_1.Label_08hiq.Enabled := .F.
*-------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------*

    DEFINE LABEL Label_11
        ROW    090
        COL    051
        WIDTH  070
        HEIGHT 020
        VALUE "Code:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {253, 209, 209 }
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_11
        ROW    090
        COL    140
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Code"
        ONCHANGE Nil
        ONGOTFOCUS  Form_1.Label_11.FontBold := .T.
        ONLOSTFOCUS Form_1.Label_11.FontBold := .F.
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR {215,255,253}
        DISABLEDFONTCOLOR {000,000,000}
        MAXLENGTH 5
        INPUTMASK Nil
        FORMAT Nil
        NUMERIC .T.
        VALUE Nil
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Label_22
        ROW    120
        COL    051
        WIDTH  070
        HEIGHT 020
        VALUE "Name:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {253, 209, 209 }
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_22
        ROW    120
        COL    140
        WIDTH  310
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Name"
        ONCHANGE Nil
        ONGOTFOCUS  Form_1.Label_22.FontBold := .T.
        ONLOSTFOCUS Form_1.Label_22.FontBold := .F.
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR {215,255,253}
        DISABLEDFONTCOLOR {000,000,000}
        MAXLENGTH 55
        INPUTMASK Nil
        FORMAT Nil
        VALUE ""
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Label_33
        ROW    150
        COL    051
        WIDTH  070
        HEIGHT 020
        VALUE "Phone:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR  {253, 209, 209 }
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_33
        ROW    150
        COL    140
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Phone"
        ONCHANGE Nil
        ONGOTFOCUS  Form_1.Label_33.FontBold := .T.
        ONLOSTFOCUS Form_1.Label_33.FontBold := .F.
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR {215,255,253}
        DISABLEDFONTCOLOR {000,000,000}
        MAXLENGTH 9
        INPUTMASK Nil
        FORMAT Nil
        NUMERIC .F.
        VALUE ""
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Label_44
        ROW    180
        COL    051
        WIDTH  070
        HEIGHT 020
        VALUE "Date:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR  {253, 209, 209 }
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_44
        ROW    180
        COL    140
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Date"
        ONCHANGE Nil
        ONGOTFOCUS  Form_1.Label_44.FontBold := .T.
        ONLOSTFOCUS Form_1.Label_44.FontBold := .F.
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR {215,255,253}
        DISABLEDFONTCOLOR {000,000,000}
        MAXLENGTH 10
        INPUTMASK "99/99/9999"
        FORMAT Nil
        NUMERIC .F.
        VALUE DTOC(DATE())
    END TEXTBOX

*-----------------------------------------------------------------*

     DEFINE LABEL Label_55
        ROW    210
        COL    051
        WIDTH  070
        HEIGHT 020
        VALUE "N Photo:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR  {253, 209, 209 }
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_55
        ROW    210
        COL    140
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "N Photo"
        ONCHANGE Nil
        ONGOTFOCUS  Form_1.Label_55.FontBold := .T.
        ONLOSTFOCUS Form_1.Label_55.FontBold := .F.
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR {215,255,253}
        DISABLEDFONTCOLOR {000,000,000}
        MAXLENGTH 10
        INPUTMASK "99999"
        FORMAT Nil
        NUMERIC .F.
        VALUE ""
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Edit11
        ROW    087
        COL    357
        WIDTH  070
        HEIGHT 020
        VALUE "Notes:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR  {253, 209, 209 }
        FONTCOLOR NIL
    END LABEL

    DEFINE EDITBOX Edit_11
        ROW    090
        COL    467
        WIDTH  235
        HEIGHT 142
        VALUE ""
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Notes"
        ONCHANGE Nil
        ONGOTFOCUS  Form_1.Edit11.FontBold := .T.
        ONLOSTFOCUS Form_1.Edit11.FontBold := .F.
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        HSCROLLBAR .T.
        VSCROLLBAR .T.
        DISABLEDBACKCOLOR {215,255,253}
        DISABLEDFONTCOLOR {000,000,000}
    END EDITBOX

    DEFINE LABEL Label_66a
        ROW    150
        COL    357
        WIDTH  080
        HEIGHT 020
        VALUE "Married:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR  {253, 209, 209 }
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_66
        ROW    180
        COL    357
        WIDTH  040
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Married"
        ONCHANGE Nil
        ONGOTFOCUS  Form_1.Label_66a.FontBold := .T.
        ONLOSTFOCUS Form_1.Label_66a.FontBold := .F.
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR {215,255,253}
        DISABLEDFONTCOLOR {000,000,000}
        MAXLENGTH 3
        INPUTMASK NIL
        FORMAT Nil
        NUMERIC .F.
        VALUE ""
    END TEXTBOX
*---------------------------------------------------------------------*
*---------------------------------  Photo  ---------------------------*
*---------------------------------------------------------------------*

    DEFINE LABEL Lab_Photo
        ROW    212
        COL    885
        WIDTH  070
        HEIGHT 020
        VALUE "Photo:"
        FONTNAME "Arial"
        FONTSIZE 11
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR  { 031,154,108 }
        FONTCOLOR NIL
    END LABEL

*--------------------------------------------------- Photo -------------------------------------------------------*

       BoxShadow(260, 766, 318, 249 ,"02aZ" ,"02aX", 255 , 255 ,255 ) 
               Form_1.Label_02aZ.Enabled := .F.   // <---- Necessary with Texbox (write)
               Form_1.Label_02aX.Enabled := .F.   // <---- Necessary with Texbox (write)

      DEFINE IMAGE ImagePhoto
           ROW 259 ; COL 765 ; WIDTH 310 ; HEIGHT 240    
           PICTURE ("Photo\"+ SUBSTR( Photo,7,5 )+".jpg")
           STRETCH .T.
       END IMAGE

*------------------------------------------------------------------------------------------------------------------*

*-------------------------------------------------------------------------------*
*-------------------------------- Ordenado por:---------------------------------*
*-------------------------------------------------------------------------------*


   MiFrame( 090,810,180,083,"frame_00","Sort by",{007 ,002 , 204},{ 031,154,108 } )

    DEFINE LABEL Label_7
        ROW    060
        COL    870
        WIDTH  100
        HEIGHT 024
        VALUE "Sort by:"   //<---------- "Ordenado por:"
        FONTNAME "Arial"
        FONTSIZE 11
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 031,154,108 }
        FONTCOLOR NIL
    END LABEL

    DEFINE RADIOGROUP  Radio_SetIndex
        ROW    100
        COL    887
        WIDTH  100
        HEIGHT 050
        OPTIONS {'Code','Name'}
        VALUE 1
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Code Name"
        ONCHANGE SetNewIndex()
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        SPACING 25
        BACKCOLOR { 031,154,108 }
        FONTCOLOR NIL
        READONLY Nil
        HORIZONTAL .F.
    END RADIOGROUP

    DEFINE IMAGE Radio_1
         ROW    108
         COL    842
         WIDTH  030
         HEIGHT 039
         PICTURE "Resource\ONxx.jpg"
         HELPID Nil
         VISIBLE .T.
         STRETCH .F.
         ACTION Nil
     END IMAGE

     DEFINE IMAGE Radio_2
         ROW    108
         COL    842
         WIDTH  030
         HEIGHT 039
         PICTURE "Resource\OFFxx.jpg"
         HELPID Nil
         VISIBLE .F.
         STRETCH .F.
         ACTION Nil
     END IMAGE

*------------------------------------------------------------------------------------------------------------------*
*------------------------------------------------------- Browse ---------------------------------------------------*
*------------------------------------------------------------------------------------------------------------------*

        BoxShadow(279, 041, 680, 250 ,"03a" ,"03aX", 255 , 189 ,061 )

                   Form_1.Label_03a.Enabled  := .F.    // <---- Necessary with Texbox (write)
                   Form_1.Label_03aX.Enabled := .F.    // <---- Necessary with Texbox (write)

*-------------------------------------------------------------------------------------------------------------------*

*--------------------------------------------------- Color Barra Video Inversa -------------------------------------*
  _HMG_SYSDATA [ 348 ] := { 199,250,225 }   
  _HMG_SYSDATA [ 349 ] := { 007,071,041 }   
  _HMG_SYSDATA [ 350 ] := { 235,237,095 }    
  _HMG_SYSDATA [ 351 ] := { 069,015,135 }    
*-------------------------------------------------------------------------------------------------------------------*

 Private bColor := { || if ( OrdKeyNo()/2 == int(OrdKeyNo()/2) , { 238,180,180 } , { 127,255,212 } ) } 
 Private fColor := { || if ( recno()/2 == int(recno()/2) ,  {000,168,000} , { 015,000,255 } ) }

*-------------------------------------------------------------------------------------------------------------------*

   SELECT 1 
   
   ficher := 'test'
   aTable := { 'test->Code' , 'test->Name' , 'test->Phone' , 'test->Date', 'test->Married', 'test->Notes' , 'test->Photo'}

     DEFINE BROWSE Browse_1
        ROW    290
        COL    051
        WIDTH  651
        HEIGHT 220
        VALUE 1
        WIDTHS  { 085, 262 , 110 , 115 , 075 , 0 , 0}                   // 0 <------------------- porque asi no sale en Browse
        HEADERS {"Code", "Name", "Phone", "Date", "Married", "", ""}    //"Notes" "" <----------- because that's not in Browse
        WORKAREA &ficher
        FIELDS   aTable
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Database ---> Test"
        ONCHANGE ArribAbajo()
        ONLOSTFOCUS ArribAbajo()
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONDBLCLICK  ( ArribAbajo() ,ANULAR_BOTO() , Apoyox_2() )    
        ALLOWEDIT .F.
        ALLOWAPPEND .F.
        ALLOWDELETE .F.
        LOCK .F.
        VSCROLLBAR .F.
        DYNAMICFORECOLOR { fcolor, fcolor, fcolor, fcolor, fcolor, fcolor, fcolor }  
        DYNAMICBACKCOLOR { bcolor, bcolor, bcolor, bcolor, bcolor, bcolor, bcolor }
        BACKCOLOR { 209,238,238 }
        FONTCOLOR { 000,000,000 }
        IMAGE Nil
        JUSTIFY { BROWSE_JTFY_RIGHT , BROWSE_JTFY_LEFT , BROWSE_JTFY_LEFT , BROWSE_JTFY_LEFT , BROWSE_JTFY_LEFT , BROWSE_JTFY_LEFT , BROWSE_JTFY_LEFT }
        NOLINES .F.
    END BROWSE

*----------------------------------------------------------------------------------------------------*
*------------------------------------- Find For Code & For Name -------------------------------------*
*----------------------------------------------------------------------------------------------------*

  MiFrame( 630,040,470,040,"Frame_0x","Find",{007 ,002 , 204},{ 031,154,108 } )   // 640 

  DEFINE LABEL Label_001
        ROW    640   
        COL    050
        WIDTH  110
        HEIGHT 020
        VALUE "Find For Code:"
        FONTNAME "Arial"
        FONTSIZE 10
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 031,154,108 }   
        FONTCOLOR NIL
   END LABEL

   DEFINE LABEL Label_002
        ROW    640 
        COL    050
        WIDTH  110
        HEIGHT 020
        VALUE "Find For Name:"
        FONTNAME "Arial"
        FONTSIZE 10
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 031,154,108 }   
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX TxtSearch
        ROW    638  
        COL    167
        WIDTH  288  
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 10  
        TOOLTIP "Search by Code or by Name"
        ONCHANGE    NIL                //     ---->  Falla  SearchData()   
        ONGOTFOCUS  NIL
        ONLOSTFOCUS NIL               //      --->  Solo un poco Bien  SearchData()   
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER SearchData()
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 40
        BACKCOLOR  { 253, 209, 209 }
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        NUMERIC .F.
        VALUE ""
    END TEXTBOX

*---------------------------------------------------------------------*
*--------------------------- N Records ------------------------------*
*---------------------------------------------------------------------*

     MiFrame( 617,590,130,51,"Frame_03","Records Database",{007 ,002 , 204},{ 031,154,108 } )   

     @ 633, 632 Label Label_2G     ;
                WIDTH   060        ;
                HEIGHT  025        ;
                FONT "Arial"  SIZE 13 BOLD ;
                BACKCOLOR { 031,154,108 }   ;
                FONTCOLOR { 000,000,000 }   ;
                VALUE ""

*---------------------------------------------------------------------*
*---------------------------------------------------------------------*

*---------------------------------------------------------------------*
*-----------------------------  BUTTONS ------------------------------*
*---------------------------------------------------------------------*

    DEFINE BUTTON  Bnuevo
        ROW    550 
        COL    040
        WIDTH  105
        HEIGHT 052
        ACTION (  ANULAR_BOTO() , Apoyox_1() )
        CAPTION SPACE(3)-"New"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "New"
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource/new.Bmp"
        PICTALIGNMENT  LEFT
    END BUTTON

    DEFINE BUTTON Bmodificar
        ROW    550 
        COL    149
        WIDTH  105
        HEIGHT 052
        ACTION ( ArribAbajo(), ANULAR_BOTO() , Apoyox_2() )
        CAPTION SPACE(4)-"Change"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Change"
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource/Modify.bmp"
        PICTALIGNMENT LEFT
    END BUTTON

    DEFINE BUTTON Beliminar
        ROW    550  
        COL    259   
        WIDTH  105
        HEIGHT 052
        ACTION Eliminar()
        CAPTION "Delete"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP SPACE(5)-"Delete"
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "Resource/Erase.Bmp"
        PICTALIGNMENT LEFT
    END BUTTON

    DEFINE BUTTON Bimprime
        ROW    550  
        COL    369  
        WIDTH  105
        HEIGHT 052
        ACTION (  ANULAR_BOTO() , mPrinting() )
        CAPTION SPACE(5)-"Print"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "List by Code or by Name"
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "Resource/Print.bmp"
        PICTALIGNMENT LEFT
    END BUTTON

    DEFINE BUTTON BwebCam
        ROW    550  
        COL    479 
        WIDTH  105
        HEIGHT 052
        ACTION ( ANULAR_BOTO() , READYCAM() )
        CAPTION  SPACE(5)-"WebCam"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "WebCam Photo"
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "Resource/WebCam1.bmp"   
        PICTALIGNMENT LEFT
    END BUTTON


*---------------------------------------------------------------------*
*---------------------------- Exit -----------------------------------*
*---------------------------------------------------------------------*

     DEFINE BUTTON BCounter  
         ROW    550  
         COL    850
         WIDTH  105  
         HEIGHT 053  
         ACTION ( ANULAR_BOTO()  , nCounterum() )
         CAPTION SPACE(2)-"Counter"  
         PICTURE "Resource\counter.bmp"
         PICTALIGNMENT LEFT 
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .T.
         FONTITALIC .T.
         TOOLTIP "Counter "        
    END BUTTON

    DEFINE BUTTON Bsalir
        ROW    620  
        COL    850
        WIDTH  105
        HEIGHT 053
        ACTION  FinalProgram()
        CAPTION SPACE(5)-"Exit"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Exit"
        FONTBOLD .T.
        FONTITALIC .F.
        PICTURE "Resource/Exit.Bmp"
        PICTALIGNMENT LEFT
    END BUTTON

*-------------------------------------------------------------------------------------*
*----------------------------------------  Up-Down  ----------------------------------*
*-------------------------------------------------------------------------------------*

     MiFrame( 554,590,130,44,"frame_01","Up-Down",{007 ,002 , 204},{ 031,154,108 }  )   

*-------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------*
  
    DEFINE BUTTON But_01
         ROW    562  
         COL    595
         WIDTH  030
         HEIGHT 030
         PICTURE "Resource/Imagen01.jpg"
         TOOLTIP 'First'
         ACTION ( DbGoTop() , Form_1.Browse_1.value := ( ficher)->(recno())  )
    END BUTTON

    DEFINE BUTTON But_02
         ROW    562  
         COL    625
         WIDTH  030
         HEIGHT 030
         PICTURE "Resource/Imagen02.jpg"
         TOOLTIP 'Previous'
         ACTION ( DbSkip(-1) , Form_1.Browse_1.value := ( ficher)->(recno())  )     
    END BUTTON

    DEFINE BUTTON But_03
         ROW    562  
         COL    655
         WIDTH  030
         HEIGHT 030
         PICTURE "Resource/Imagen03.jpg"
         TOOLTIP 'Next'
         ACTION ( DbSkip(1) ,if ( eof() , DbGoBottom() , Nil ) , Form_1.Browse_1.value := ( ficher)->(recno()) )
    END BUTTON

    DEFINE BUTTON But_04
         ROW    562  
         COL    685
         WIDTH  030
         HEIGHT 030
         PICTURE "Resource/Imagen04.jpg"
         TOOLTIP 'Last'
         ACTION ( DbGoBottom() , Form_1.Browse_1.value := ( ficher)->(recno()) )
    END BUTTON

*---------------------------------------------------------------------*
*--------------------------- End  Up-Down  ---------------------------*
*---------------------------------------------------------------------*

    DEFINE BUTTON But_06
         ROW    635  
         COL    472 
         WIDTH  029
         HEIGHT 029
         PICTURE "Resource/Find.bmp"
         TOOLTIP 'Go'
         ACTION SearchData()
    END BUTTON

      SETWINDOWCURSOR ( Form_1.Bsalir.Handle , "resource\finger.cur")

      Chane_Style()  

   END WINDOW

   Form_1.Label_001.Visible := .T.
   Form_1.Label_002.Visible := .F.

   Form_1.Browse_1.value := 1
   Form_1.Browse_1.Refresh

   CENTER WINDOW Form_1
   ACTIVATE WINDOW Form_1

Return Nil


*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

*------------------------------------------------------------* 
 FUNCTION Chane_Style()   // Hace Recuadro en Browse_1  
*------------------------------------------------------------* 

 HMG_ChangeWindowStyle ( GetControlHandle("Browse_1","Form_1"), LVS_REPORT, NIL, .T. )

Return

*------------------------------------------------------------*
  FUNCTION DateBien()
*------------------------------------------------------------* 
* Para que salgan Bien las Fechas 

  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO SPANISH

  SET CENTURY ON
  SET DATE FRENCH
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET EPOCH TO 2000

Return .T.
*------------------------------------------------------------*
  FUNCTION FinalProgram()
*------------------------------------------------------------*

 IF MsgYesNo("Do you want to finish the program ?","Atention !!!") = .T.
      CLOSE DATABASES
      Form_1.Release
      Return .T.
 EndIf

Return .T.
*------------------------------------------------------------* 
  FUNCTION PositionData()  // N de Registro / Total  Solo sirve para el Browse 
*------------------------------------------------------------*
   PRIVATE  nValor , nCouR 

   nValor := ( ficher)->(recno())           
   Select('test')
   nCouR  := LASTREC() 
   Form_1.Label_2G.value := ALLTRIM( STR(nValor) ) + SPACE(1) + "/" + SPACE(1) + ALLTRIM( STR(nCouR) )    

Return 

*------------------------------------------------------------*
  FUNCTION ArribAbajo()
*------------------------------------------------------------*
     Form_1.TEXT_11.value       := TEST->Code
     Form_1.TEXT_22.value       := TEST->Name
     Form_1.TEXT_33.value       := TEST->Phone
     Form_1.TEXT_44.value       := DTOC(TEST->Date)
     Form_1.TEXT_55.value       := SUBSTR( TEST->Photo,7,5 )
     Form_1.TEXT_66.value       := TEST->Married
     Form_1.EDIT_11.value       := TEST->Notes
     Form_1.ImagePhoto.Picture  := ("Photo\"+ SUBSTR( TEST->Photo,7,5 )+".jpg")

     PositionData()  

 Return

*------------------------------------------------------------*
  FUNCTION ACTIVA_BOTO()
*------------------------------------------------------------*
     Form_1.Bnuevo.Enabled     := .T.
     Form_1.Bmodificar.Enabled := .T.
     Form_1.Beliminar.Enabled  := .T.
     Form_1.Bimprime.Enabled   := .T.
     Form_1.BwebCam.Enabled    := .T.
     Form_1.BCounter.Enabled   := .T. 

     Form_1.But_01.Enabled     := .T.
     Form_1.But_02.Enabled     := .T.
     Form_1.But_03.Enabled     := .T.
     Form_1.But_04.Enabled     := .T.

     Form_1.But_06.Enabled     := .T.

     Form_1.Bsalir.Enabled     := .T.

 Return

*------------------------------------------------------------*
  FUNCTION  ANULAR_BOTO()
*------------------------------------------------------------*
     Form_1.Bnuevo.Enabled     := .F.
     Form_1.Bmodificar.Enabled := .F.
     Form_1.Beliminar.Enabled  := .F.
     Form_1.Bimprime.Enabled   := .F.
     Form_1.BwebCam.Enabled    := .F.
     Form_1.BCounter.Enabled   := .F. 

     Form_1.But_01.Enabled     := .F.
     Form_1.But_02.Enabled     := .F.
     Form_1.But_03.Enabled     := .F.
     Form_1.But_04.Enabled     := .F.

     Form_1.But_06.Enabled     := .F.

     Form_1.Bsalir.Enabled     := .F.

 Return

*------------------------------------------------------------*
  FUNCTION CloseTable()
*------------------------------------------------------------*

   DbCloseAll()

Return

*------------------------------------------------------------*
 FUNCTION Select_Photo()
*------------------------------------------------------------*

  PUBLIC PhotoFile , ficherAaX
  PUBLIC aFilters := { {'jpg Files','*.jpg'} }
	
  PhotoFile := Getfile ( { {'All Files','*.*'} } , 'Select Photo' , 'PHOTO\' , .F. , .T. )

*------------------------------------------------------------*

 IF .NOT. FILE ( PhotoFile )
      MsgInfo("No se ha elejido Photo "," ATENCION !!!")
     RETURN
 ENDIF
*------------------------------------------------------------*

*---------------------------------------------------------------------------------------------------*
   ficherAaX := RIGHT( PhotoFile , LEN(PhotoFile) - RAT("\", PhotoFile ))
*------------------------------ Calcula Longitud Fichero jpg ---------------------------------------*
   Nuevo =  LEFT (ficherAaX, LEN( ficherAaX ) - 4 )

   SAVE TO Photo_Num ALL LIKE Nuevo
*------------------------------------ View Changes Photo  ------------------------------------------*

   IF IsWindowDefined( Form_2 )
      Declare Window Form_2
      RESTORE FROM Photo_Num.mem ADDITIVE
      Form_2.Mostraryx.Picture := "Photo\"+ALLTRIM(Nuevo)+".jpg"   
      Form_2.Control_6.value := ALLTRIM(NUEVO)

     IF NUEVO == ""
        Form_2.Control_6.value := "00000"
     ENDIF
      Declare Window Win_1
   ENDIF

*---------------------------------------------------------------------------------------------------*

   IF IsWindowDefined( Form_2x )
      Declare Window Form_2x
      RESTORE FROM Photo_Num.mem ADDITIVE
      Form_2x.Mostrary.Picture := "Photo\"+ALLTRIM(Nuevo)+".jpg"  
      Form_2x.Control_6x.value := ALLTRIM(NUEVO)

     IF NUEVO == ""
        Form_2X.Control_6X.value := TEST->(SUBSTR( Photo,7,5 ) )
     ENDIF
      Declare Window Win_1
   ENDIF

  Return Nil

*****************************************************************************************************
*****************************************************************************************************

*------------------------------------------------------------*
  FUNCTION Altax()
*------------------------------------------------------------*
  SELECT 1
  DELETE FOR test->code <= 0
  PACK

     IF UPPER( Form_2.Control_2.Value ) <= SPACE(1)
       msgStop('Write Full Name!','warning!')
       return
     ENDIF

*--------------------------------- Seleccin de Photo ---------------------------------*

         IF Form_2.Control_6.value == "00000" .OR. Form_2.Control_6.value == ""

                         RESTORE FROM Photo_Num.mem ADDITIVE
           ELSE
                         Nuevo =  Form_2.Control_6.value
                         SAVE TO Photo_Num ALL LIKE Nuevo
         ENDIF

*----------------------------------------------------------------------------------------*

          IF Nuevo == ""
                        Nuevo =  "00000"
                        SAVE TO Photo_Num ALL LIKE Nuevo
          ENDIF

                        RESTORE FROM Photo_Num.mem ADDITIVE

*----------------------------------------------------------------------------------------*
   SELECT 1
   USE TEST 

   APPEND BLANK
   REPLACE test->Code      WITH Form_2.Control_1.Value
   REPLACE test->Name      WITH UPPER( Form_2.Control_2.Value )
   REPLACE test->Phone     WITH Form_2.Control_3.Value
   REPLACE test->Date      WITH CTOD(Form_2.Control_4.Value)
   REPLACE test->Married   WITH UPPER( Form_2.Control_5.Value )
   REPLACE test->Notes     WITH Form_2.Edit_1.Value
   REPLACE test->Photo     WITH "Photo\"+ALLTRIM( Nuevo )+".jpg"

*-------------------------------------------------------------*

   DbGoBottom()

   Form_1.Browse_1.value := ( ficher)->(recno())

   ArribAbajo()

   Form_1.Browse_1.Value := RECNO()
   Form_1.Browse_1.Refresh

Return

*-------------------------------------------------------------*
  FUNCTION Eliminar()
*-------------------------------------------------------------*

  SELECT('test')
  GO  Form_1.Browse_1.Value

  IF MsgYesNo( "Proceed to remove the Record ?"+CRLF+CRLF+;
                    "Code:   "+ SPACE(1) + LTRIM(STR(test->Code)) + CRLF+ ;
                    "Name:   "+          ALLTRIM( test->Name )  + CRLF+ ;
                    "Phone:  "+ SPACE(1) + LTRIM( test->Phone ) + CRLF+ ;
                    "Date:   "+ SPACE(3) + DTOC(TEST->Date) ,"Delete Records" )

 SELECT('test')
 GO  Form_1.Browse_1.Value
   DELETE
   PACK
    SKIP
   IF EOF()
     GO TOP
      IF BOF()
         lExistRecords := .F.
      ENDIF
   ENDIF
          DbGoTop() 
          Form_1.Browse_1.value :=  ( ficher)->(recno() )   
    
   Form_1.Browse_1.Refresh

  ENDIF

RETURN(Nil)

*------------------------------------------------------------*
  FUNCTION SearchData()
*------------------------------------------------------------*

  Local Buscar , BuscarN, FindWar , FindWarN, lFound := .T.   

  BuscarN := VAL( Form_1.txtSearch.value)                       
  Buscar  := Upper ( AllTrim ( Form_1.txtSearch.value ))

  RESTORE FROM control.mem ADDITIVE

   DO CASE
       CASE  Form_1.Radio_SetIndex.value = 1
     
   SET SOFTSEEK OFF
        head1()

       GO TOP
       SEEK BuscarN
       IF !FOUND()
           MsgExclamation ( 'No Success!'+CRLF+"Change Properties!", 'Error' )
       ENDIF

      Form_1.Browse_1.Value := RECNO()
      Form_1.Browse_1.Refresh()

   ArribAbajo()
      Form_1.txtSearch.value := ""
      Form_1.txtSearch.SetFocus

   SET SOFTSEEK ON

      CASE  Form_1.Radio_SetIndex.value = 2
  
   SET SOFTSEEK OFF 

      head2()

   SET SOFTSEEK ON

      GO TOP
      SEEK   Buscar
      IF !FOUND()
         MsgExclamation ( 'No Success!'+CRLF+"Change Properties!", 'Error' )
      ENDIF

      Form_1.Browse_1.Value := RECNO()
      Form_1.Browse_1.Refresh()

   ArribAbajo()

      Form_1.txtSearch.value := ""  
      Form_1.txtSearch.SetFocus 

   SET SOFTSEEK ON

  ENDCASE

RETURN Nil

*------------------------------------------------------------*
 FUNCTION SetNewIndex()
*------------------------------------------------------------*

 RESTORE FROM control.mem ADDITIVE

 DO CASE
       CASE  Form_1.Radio_SetIndex.Value = 1
             Form_1.Radio_1.VISIBLE := .T.
             Form_1.Radio_2.VISIBLE := .F.
             
             Form_1.Label_001.Visible := .T.
             Form_1.Label_002.Visible := .F.

             nOrder := 1
             SAVE TO control.mem ALL LIKE nOrder*
             head1()

       CASE  Form_1.Radio_SetIndex.Value = 2
             Form_1.Radio_1.VISIBLE := .F.
             Form_1.Radio_2.VISIBLE := .T.

             Form_1.Label_001.Visible := .F.
             Form_1.Label_002.Visible := .T.

             nOrder := 2
             SAVE TO control.mem ALL LIKE nOrder*
            head2()
  ENDCASE

  Form_1.Browse_1.value := 1    // ?
  Form_1.Browse_1.Value := RECNO()
  Form_1.Browse_1.Refresh

Return Nil

*------------------------------------------------------------*
 FUNCTION head1()
*------------------------------------------------------------*
    INDEX ON TEST->Code TO Code
    DBGOTOP()
    Form_1.Browse_1.Refresh
    ArribAbajo()
    Form_1.txtSearch.Value:= " "
    Form_1.txtSearch.SetFocus() 

RETURN

*------------------------------------------------------------*
 FUNCTION head2()
*------------------------------------------------------------*
   INDEX ON TEST->Name TO Name
   DBGOTOP()
   Form_1.Browse_1.Refresh
   ArribAbajo()
   Form_1.txtSearch.Value:= " "
   Form_1.txtSearch.SetFocus() 

RETURN

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

*------------------------------------------------------------------------------------------------*
*----------------------------------------  Change  Registros ------------------------------------*
*------------------------------------------------------------------------------------------------*

*------------------------------------------------------------*
  FUNCTION Apoyox_2()
*------------------------------------------------------------*


    Nuevo =  "00000"
    SAVE TO Photo_Num ALL LIKE Nuevo

     DEFINE WINDOW Form_2x       ;
         AT 0,0                  ;
         WIDTH  700              ;
         HEIGHT 320              ;
         NOCAPTION               ;
         BACKCOLOR {150,234,203} ;
         TOPMOST                 ;
         CHILD NOSIZE

         ON KEY ESCAPE ACTION ( ACTIVA_BOTO() , Form_2x.Release )

*------------------------------------------------------------*

     BoxShadow( 007, 006, 694, 314 ,"02sx" ,"02sz", 137,115,183 )

        Form_2x.Label_02sx.Enabled := .F.
        Form_2x.Label_02sz.Enabled := .F.

*------------------------------------------------------------*

  DEFINE LABEL Label_0x
        ROW    020
        COL    290
        WIDTH  200
        HEIGHT 030
        VALUE "Change Record"
        FONTNAME "Arial"
        FONTSIZE 13
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183}
        FONTCOLOR NIL
   END LABEL

*------------------------------------------------------------*

   DEFINE LABEL Label_1x
        ROW    047
        COL    020
        WIDTH  080
        HEIGHT 020
        VALUE "Code:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183}
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX  Control_1x
        ROW    047
        COL    100
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Code"
        ONCHANGE Nil
        ONGOTFOCUS  Form_2x.Label_1x.FontBold := .T.
        ONLOSTFOCUS Form_2x.Label_1x.FontBold := .F.
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 5
        BACKCOLOR {253,209,209}
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        NUMERIC .T.
        VALUE ""
    END TEXTBOX
		
*-----------------------------------------------------------------*

    DEFINE LABEL Label_2x
        ROW    077
        COL    020
        WIDTH  080
        HEIGHT 020
        VALUE "Name:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183}
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Control_2x
        ROW    077
        COL    100
        WIDTH  310
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Name"
        ONCHANGE Nil
        ONGOTFOCUS  Form_2x.Label_2x.FontBold := .T.
        ONLOSTFOCUS Form_2x.Label_2x.FontBold := .F.
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 40
        BACKCOLOR  { 253,209,209 }
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        VALUE ""
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Label_3x
        ROW    107
        COL    020
        WIDTH  080
        HEIGHT 020
        VALUE "Phone:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183}
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Control_3x
        ROW    107
        COL    100
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Phone"
        ONCHANGE Nil
        ONGOTFOCUS  Form_2x.Label_3x.FontBold := .T.
        ONLOSTFOCUS Form_2x.Label_3x.FontBold := .F.
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 9
        BACKCOLOR { 253,209,209 }
        FONTCOLOR NIL
        INPUTMASK '999999999'
        FORMAT Nil
        NUMERIC .F.
        VALUE "0"
    END TEXTBOX

*-----------------------------------------------------------------*
		
    DEFINE LABEL Label_4x
        ROW    137
        COL    020
        WIDTH  080
        HEIGHT 020
        VALUE "Date:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183}
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Control_4x
        ROW    137
        COL    100
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Date"
        ONCHANGE Nil
        ONGOTFOCUS  Form_2x.Label_4x.FontBold := .T.
        ONLOSTFOCUS Form_2x.Label_4x.FontBold := .F.
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 10
        BACKCOLOR {253,209,209}
        FONTCOLOR NIL
        INPUTMASK "99/99/9999"
        FORMAT Nil
        NUMERIC .F.
        VALUE DTOC(DATE())
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Label_5x
        ROW    167
        COL    020
        WIDTH  080
        HEIGHT 020
        VALUE "Married:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183}
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Control_5x
        ROW    167
        COL    100
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Married, Yes or No"
        ONCHANGE Nil
        ONGOTFOCUS  Form_2x.Label_5x.FontBold := .T.
        ONLOSTFOCUS( If (.NOT.(This.Value $ "YESNO") , EVAL({|| This.SetFocus, This.Value:= 'NO'}), NIL ) , Form_2x.Label_5x.FontBold := .F. )
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 3
        BACKCOLOR { 253,209,209 }
        FONTCOLOR NIL
        INPUTMASK "!!!"
        FORMAT Nil
        NUMERIC .F.
        VALUE ""
    END TEXTBOX

    DEFINE LABEL LABEL_6x
        ROW    198
        COL    020
        WIDTH  070
        HEIGHT 020
        VALUE "N Photo:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183}
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Control_6x
        ROW    197
        COL    100
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "N Photo"
        ONCHANGE Nil
        ONGOTFOCUS  Form_2x.Label_6x.FontBold := .T.
        ONLOSTFOCUS Form_2x.Label_6x.FontBold := .F.
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 10
        BACKCOLOR {253,209,209}
        FONTCOLOR NIL
        INPUTMASK "99999"
        FORMAT Nil
        NUMERIC .F.
        VALUE "00000"
    END TEXTBOX

*--------------------------- Box Photo ---------------------------*

     Box( 109,259,134 , 119 ,"01aQ", 240 ,240,240 )     

     DEFINE IMAGE Mostrary
           ROW 113 ; COL 264 ; WIDTH 124 ; HEIGHT 111   
           PICTURE ''
           STRETCH .T.
     END IMAGE
*-----------------------------------------------------------------*

    DEFINE LABEL LABEL_7x
        ROW    249 
        COL    020  
        WIDTH  120
        HEIGHT 020
        VALUE "Change Photo:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183}
        FONTCOLOR NIL
    END LABEL

*---------------------------------------------------------------------*

      @ 240,112 BUTTON ModifY_Photo    ; 
                CAPTION "Photo"        ;
                PICTURE "Resource\portrait_delete.bmp" LEFT ;
		TOOLTIP "Change Photo" ;
		ACTION Select_Photo()  ;
		WIDTH 100              ;
		HEIGHT 40              ;
                FONT "ARIAL" SIZE 9 BOLD

*---------------------------------------------------------------------*

    DEFINE LABEL Edit1x
        ROW    047
        COL    327
        WIDTH  070
        HEIGHT 020
        VALUE "Notes:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183}
        FONTCOLOR NIL
    END LABEL

    DEFINE EDITBOX Edit_1x
        ROW    047
        COL    440
        WIDTH  235
        HEIGHT 175
        VALUE ""
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Notes"
        ONCHANGE Nil
        ONGOTFOCUS  Form_2x.Edit1x.FontBold := .T.
        ONLOSTFOCUS Form_2x.Edit1x.FontBold := .F.
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        HSCROLLBAR .T.
        VSCROLLBAR .T.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        BACKCOLOR { 253,209,209 }
        FONTCOLOR Nil
    END EDITBOX

*---------------------------------------------------------------------*
*---------------------------------------------------------------------*

       @ 240, 235 BUTTON SAVE_EMPLx  ;
         CAPTION "&Save"             ;
         PICTURE "Resource\ok.bmp"   ;
         FONT "Arial"                ;
         SIZE 9                      ;
         BOLD                        ;
         ITALIC                      ;
         ACTION ( Editax() , ACTIVA_BOTO() , Form_2x.Release() ) ;
         TOOLTIP "Save"              ;
         RIGHT                       ;
         WIDTH 100                   ;
         HEIGHT 40

       @ 240,335 BUTTON CANCEL_EMPLx ;
         CAPTION "&Cancel"           ;
         PICTURE "resource\cancel.bmp" ;
         FONT "Arial"                ;
         SIZE 9                      ;
         BOLD                        ;
         ITALIC                      ;
         ACTION ( ACTIVA_BOTO() , Form_2x.Release() ) ;
         TOOLTIP "Cancel"            ;
         RIGHT                       ;
         WIDTH 100                   ;
         HEIGHT 40

*---------------------------------------------------------------------*
*---------------------------------------------------------------------*

   Contro()

   END WINDOW

   CENTER WINDOW Form_2x
   ACTIVATE WINDOW Form_2x

return nil

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*


*------------------------------------------------------------*
  FUNCTION Contro()
*------------------------------------------------------------*

    GO  Form_1.Browse_1.Value

        Form_2x.Control_1x.Value := test->Code
        Form_2x.Control_2x.Value := test->Name
        Form_2x.Control_3x.Value := test->Phone
        Form_2x.Control_4x.Value := DTOC(test->Date)
        Form_2x.Control_5x.Value := test->Married
        Form_2x.Edit_1x.Value    := test->Notes
        Form_2x.Control_6x.Value := SUBSTR( test->Photo,7,5 )
        Form_2x.Mostrary.Picture := 'Photo\'+SUBSTR( test->Photo,7,5 )+'.jpg'
Return

*------------------------------------------------------------*
  FUNCTION Editax()
*------------------------------------------------------------*

  SET CODEPAGE TO SPANISH
  SET LANGUAGE TO SPANISH
*--------------------------------- Seleccin de Photo ---------------------------------*

        IF Form_2x.Control_6x.value == "00000" .OR. Form_2x.Control_6x.value == ""

               RESTORE FROM Photo_Num.mem ADDITIVE
        ELSE
               Nuevo =  Form_2x.Control_6x.value
               SAVE TO Photo_Num ALL LIKE Nuevo
        ENDIF

*----------------------------------------------------------------------------------------*

        IF Nuevo == ""
               Nuevo =  SUBSTR( Photo,7,5 )                //"00000"
               SAVE TO Photo_Num ALL LIKE Nuevo
        ENDIF
               RESTORE FROM Photo_Num.mem ADDITIVE

*----------------------------------------------------------------------------------------*

    SELECT('test')
    GO  Form_1.Browse_1.Value

    REPLACE test->Code     WITH          Form_2x.Control_1x.Value
    REPLACE test->Name     WITH   UPPER (Form_2x.Control_2x.Value )
    REPLACE test->Phone    WITH          Form_2x.Control_3x.Value
    REPLACE test->Date     WITH     CTOD(Form_2x.Control_4x.Value)  
    REPLACE test->Married  WITH   UPPER (Form_2x.Control_5x.Value )
    REPLACE test->Notes    WITH          Form_2x.Edit_1x.Value
    REPLACE test->Photo    WITH   "Photo\"+ALLTRIM( Nuevo )+".jpg"

*----------------------------------------------------------------*

   Declare Window  Form_1

   DbGoBottom()
   ArribAbajo()

   Form_1.Browse_1.Refresh    //  ?
   ( DbSkip(-1) , Form_1.Browse_1.value := ( ficher)->(recno())  )
   ( DbSkip(1) ,if ( eof() , DbGoBottom() , Nil ) , Form_1.Browse_1.value := ( ficher)->(recno()) )
   ( DbGoBottom() , Form_1.Browse_1.value := ( ficher)->(recno()) )
   Form_1.Browse_1.Value := RECNO()
   Form_1.Browse_1.Refresh

RETURN NIL   

*-----------------------------------------------------------------------------------------------------------------*
*---------------------------------------------- Menu  Impresor ---------------------------------------------------*
*-----------------------------------------------------------------------------------------------------------------*

*------------------------------------------------------------*
 FUNCTION mPrinting()
*------------------------------------------------------------*

  DEFINE WINDOW Form_2s       ;
      AT 0,0                  ;
      WIDTH 300               ;
      HEIGHT 210              ;
      NOCAPTION               ;
      BACKCOLOR {209,238,238} ;
      TOPMOST                 ;
      CHILD NOSIZE

      ON KEY ESCAPE ACTION ( ACTIVA_BOTO() , Form_2s.Release )

*------------------------------------------------------------*

    BoxShadow( 007, 006, 294, 205 ,"00sx" ,"00sz", 137,115,183 )

        Form_2s.Label_00sx.Enabled := .F.
        Form_2s.Label_00sz.Enabled := .F.

*------------------------------------------------------------*

     DEFINE FRAME frame_02
         ROW 021
         COL 090
         WIDTH  120
         HEIGHT 098
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         CAPTION "Printer"
         BACKCOLOR { 137,115,183 }
         FONTCOLOR Nil
         OPAQUE .T.
     END FRAME

     DEFINE LABEL  Label_Print
        ROW    038
        COL    111
        WIDTH  090
        HEIGHT 020
        VALUE "Printer List"
        FONTNAME "Arial"
        FONTSIZE 12
        TOOLTIP "Printer List"
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 137,115,183 }
        FONTCOLOR NIL
    END LABEL

    DEFINE RADIOGROUP RadioGroup_Print
        ROW    060
        COL    111
        WIDTH  080
        HEIGHT 050
        OPTIONS {'Printer','File Pdf'}
        VALUE 1
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE nil
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        SPACING 25
        BACKCOLOR { 137,115,183 }
        FONTCOLOR NIL
        READONLY Nil
        HORIZONTAL .F.
    END RADIOGROUP

*------------------------------------------------------------*
*------------------------------------------------------------*

     @ 140, 042 BUTTON But_Print   ;
         CAPTION "&Acept"          ;
         PICTURE "resource\ok.bmp" ;
         FONT "Arial"              ;
         SIZE 9                    ;
         BOLD                      ;
         ITALIC                    ;
         ACTION ( ACTIVA_BOTO(), Search_Print() ) ;
         TOOLTIP "Acept"           ;
         RIGHT                     ;
         WIDTH 105                 ;
         HEIGHT 40

      @ 140,148 BUTTON But_Cancel  ;
         CAPTION "&Cancel"         ;
         PICTURE "resource\cancel.bmp" ;
         FONT "Arial"              ;
         SIZE 9                    ;
         BOLD                      ;
         ITALIC                    ;
         ACTION ( ACTIVA_BOTO() , Form_2s.Release ) ;
         TOOLTIP "Cancel"          ;
         RIGHT                     ;
         WIDTH 105                 ;
         HEIGHT 40

  END WINDOW

   CENTER WINDOW Form_2s
   ACTIVATE WINDOW Form_2s

RETURN NIL  

*-----------------------------------------------------------------------------------------------------------------*
*-----------------------------------------------  Impresor -------------------------------------------------------*
*-----------------------------------------------------------------------------------------------------------------*

*------------------------------------------------------------*
  FUNCTION Search_Print()
*------------------------------------------------------------*

  RESTORE FROM control.mem ADDITIVE

  IF nOrder = 1

   DO CASE

      CASE  Form_2s.RadioGroup_Print.value = 1

        ( Form_2s.Release , CreateReport() , ExecuteReport('Report1',.T.))

         declare window Form_1

        ( DbGoTop() , Form_1.Browse_1.value := ( ficher)->(recno())  )


      CASE  Form_2s.RadioGroup_Print.value = 2

        ( Form_2s.Release , pdf_createQ1()   )

          declare window Form_1

        ( DbGoTop() , Form_1.Browse_1.value := ( ficher)->(recno())  )

   ENDCASE

  ELSE

     DO CASE

      CASE  Form_2s.RadioGroup_Print.value = 1

        ( Form_2s.Release , CreateReport2() , ExecuteReport('Report2',.T.))

        declare window Form_1

        ( DbGoTop() , Form_1.Browse_1.value := ( ficher)->(recno())  )

      CASE  Form_2s.RadioGroup_Print.value = 2

        ( Form_2s.Release ,  pdf_createQ2()   )

        declare window Form_1

        ( DbGoTop() , Form_1.Browse_1.value := ( ficher)->(recno())  )

    ENDCASE

  ENDIF

Return Nil


*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
















