*------------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*------------------------------------------*

#include "hmg.ch"

*------------------------------------------------------------*
  FUNCTION CreateReport() 
*------------------------------------------------------------*

         nOrder := 1
   
         SAVE TO control.mem ALL LIKE nOrder*


	DEFINE REPORT Report1


		* Report Layout ***********************************************

		BEGIN LAYOUT 
			PAPERSIZE	PRINTER_PAPER_A4
			ORIENTATION	PRINTER_ORIENT_PORTRAIT 
		END LAYOUT

		* Header Band *************************************************

		BEGIN HEADER

			BANDHEIGHT	25

			BEGIN LINE
				FROMROW		23
				FROMCOL		10
				TOROW		23
				TOCOL		200
				PENWIDTH	0.1
				PENCOLOR	{ 0 , 0 , 0 }
			END LINE

			BEGIN TEXT
				EXPRESSION	'DataBase WebCam Photo'
				ROW		10  	
				COL		62 
				WIDTH		100	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	20	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left
			END TEXT

			BEGIN PICTURE
				VALUE		'Resource\Business-Pie.jpg'           
				ROW		08   	
				COL		25  	
				WIDTH		11	
				HEIGHT		11	
				STRETCH		.F.
			END PICTURE

		END HEADER

		* Detail Band *************************************************

		BEGIN DETAIL

			BANDHEIGHT	6

			BEGIN TEXT
				EXPRESSION	test->Code 
				ROW		2	
				COL		24  
				WIDTH		10	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	RIGHT  
			END TEXT

			BEGIN TEXT
				EXPRESSION	test->Name 
				ROW		2	
				COL		40 
				WIDTH		60
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	test->Phone 
				ROW		2	
				COL		103  
				WIDTH		60	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	test->Married 
				ROW		2	
				COL		135  
				WIDTH		60	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	test->Date
				ROW		2	
				COL		160 
				WIDTH		60	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			
			END TEXT

		END DETAIL

		* Footer Band *************************************************

		BEGIN FOOTER

			BANDHEIGHT	27

			BEGIN LINE
				FROMROW		4
				FROMCOL		10	
				TOROW		4	
				TOCOL		200	
				PENWIDTH	0.1	
				PENCOLOR	{ 0 , 0 , 0 }	
			END LINE

			BEGIN TEXT
				EXPRESSION	'Page. No:' + Str(_PageNo)
				ROW		7	
				COL		11	
				WIDTH		100	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	Date()
				ROW		7	
				COL		177	
				WIDTH		30	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

		END FOOTER

		* Summary Band ************************************************

		BEGIN SUMMARY

			BANDHEIGHT	50

			BEGIN TEXT
				EXPRESSION	'Total Records: ' + Str(RecCount()) 
				ROW		10
				COL		20	
				WIDTH		100	
				HEIGHT		30
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.T.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

		END SUMMARY

	END REPORT

Return


*-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-*



*------------------------------------------------------------*
  FUNCTION CreateReport2() 
*------------------------------------------------------------*

        nOrder := 1
   
        SAVE TO control.mem ALL LIKE nOrder*

      DEFINE REPORT Report2


		* Report Layout ***********************************************

		BEGIN LAYOUT 
			PAPERSIZE	PRINTER_PAPER_A4
			ORIENTATION	PRINTER_ORIENT_PORTRAIT 
		END LAYOUT

		* Header Band *************************************************

		BEGIN HEADER

			BANDHEIGHT	25

			BEGIN LINE
				FROMROW		23
				FROMCOL		10
				TOROW		23
				TOCOL		200
				PENWIDTH	0.1
				PENCOLOR	{ 0 , 0 , 0 }
			END LINE

			BEGIN TEXT
				EXPRESSION	'DataBase WebCam Photo'
				ROW		10  	
				COL		62 
				WIDTH		100	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	20	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left
			END TEXT

			BEGIN PICTURE
				VALUE		'Resource\Business-Pie.jpg'           
				ROW		08   	
				COL		25 //189	
				WIDTH		11	
				HEIGHT		11	
				STRETCH		.F.
			END PICTURE

		END HEADER

		* Detail Band *************************************************

		BEGIN DETAIL

			BANDHEIGHT	6

			BEGIN TEXT
				EXPRESSION	test->Name 
				ROW		2	
				COL		24  
				WIDTH		60	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left               
			END TEXT

			BEGIN TEXT
				EXPRESSION	test->Code 
				ROW		2	
				COL		80 
				WIDTH		10
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	RIGHT  
			END TEXT

			BEGIN TEXT
				EXPRESSION	test->Phone 
				ROW		2	
				COL		103  
				WIDTH		60	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	test->Married 
				ROW		2	
				COL		135  
				WIDTH		60	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	test->Date
				ROW		2	
				COL		160 
				WIDTH		60	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			
			END TEXT

		END DETAIL

		* Footer Band *************************************************

		BEGIN FOOTER

			BANDHEIGHT	27

			BEGIN LINE
				FROMROW		4
				FROMCOL		10	
				TOROW		4	
				TOCOL		200	
				PENWIDTH	0.1	
				PENCOLOR	{ 0 , 0 , 0 }	
			END LINE

			BEGIN TEXT
				EXPRESSION	'Page. No:' + Str(_PageNo)
				ROW		7	
				COL		11	
				WIDTH		100	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	Date()
				ROW		7	
				COL		177	
				WIDTH		30	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

		END FOOTER

		* Summary Band ************************************************

		BEGIN SUMMARY

			BANDHEIGHT	50

			BEGIN TEXT
				EXPRESSION	'Total Records: ' + Str(RecCount()) 
				ROW		10
				COL		20	
				WIDTH		100	
				HEIGHT		30
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.T.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

		END SUMMARY

	END REPORT


Return

*-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-*

*------------------------------------------------------------*
  FUNCTION pdf_createQ1()
*------------------------------------------------------------*

  SET DATE FRENCH
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET EPOCH TO 2000

   head1()

   PRIVATE pagina:= 0
   PRIVATE horaS
   PRIVATE reng  := 0
   PRIVATE TOT   := 0.00
   PRIVATE F_Mus := 60   

   PRIVATE FDIA   
   PRIVATE FDIAx  
   PRIVATE HORA  
   PRIVATE HORAx  
   PRIVATE cNombre , cNumero

*-------------------------------------------------------------------------------------*
  FDIA    := DTOC(DATE()) 
  FDIAx   := STRTRAN(FDIA, '/')    && <--------  eliminas la barra(/) 
  HORA    := LEFT(TIME(), 5) 
  HORAx   := STRTRAN(HORA, ':')    && <--------  eliminas los dos puntos(:) 
  cNombre := "Listado_Pdf\" + "Listado" + "_" + FDIAx + '_' + HORAx + '.pdf' 
  cNumero := (  FDIAx  + '_' +  HORAx )

*--------------------------------------------------------------------------------------*

*---------------------------------------------------------------------------------------------*

   SELECT HPDFDOC cNombre TO lSuccess papersize HPDF_PAPER_A4 


*-----------------------------  Cdigo Caracteres ANSI (Latinos) -----------------------------*
*------------------------------ Alternativo es lo Mismo --------------------------------------*

 * SET HPDFDOC ENCODING TO "WinAnsiEncoding"

   SET HPDFDOC ENCODING TO "CP1252"  

*---------------------------------------------------------------------------------------------*

   START HPDFDOC
              
            START HPDFPAGE
		
            pagina:=1

*------------------------------------------------ Cuadro General ------------------------------*

     @ 005,005  HPDFPRINT RECTANGLE TO 292, 206 PENWIDTH 1 ROUNDED CURVE 1  
     @ 007,007  HPDFPRINT RECTANGLE TO 290, 204            ROUNDED CURVE 1                  

*----------------------------------------------------------------------------------------------*  

     @ 021,025 HPDFPRINT IMAGE "Resource\Business-Pie.png" width 12 height 12       
     @ 030,055 HPDFPRINT "DataBase WebCam Photo"  FONT "Times-Roman" SIZE 25 ITALIC   
     @ 030,155 HPDFPRINT DTOC(DATE())             FONT "Times-Roman" SIZE 18 ITALIC
     @ 040,015 HPDFPRINT RECTANGLE TO 48, 197  ROUNDED CURVE 1    
     @ 045,026 HPDFPRINT "CODE                                         NAME  "     FONT "Times-Roman" SIZE 9 ITALIC 
     @ 045,127 HPDFPRINT "   PHONE                  DATE                 MARRIED"  FONT "Times-Roman" SIZE 9 ITALIC 

*-----------------------------------------------------------------------------------------------*

      select("test")

    DO WHILE !test->(EOF())

        reng=reng+1



*------------------------------------------------------------------------------------------*

*------------------------------------------------------------------------------------------*
   @ F_Mus,  26 HPDFPRINT  STR( test->Code )       FONT "Times-Roman" SIZE 12 ITALIC
   @ F_Mus,  41 HPDFPRINT  ALLTRIM( test->Name )   FONT "Times-Roman" SIZE 12 ITALIC
   @ F_Mus, 125 HPDFPRINT  LTRIM( test->Phone )    FONT "Times-Roman" SIZE 12 ITALIC
   @ F_Mus, 150 HPDFPRINT  DTOC(test->Date)        FONT "Times-Roman" SIZE 12 ITALIC
   @ F_Mus, 180 HPDFPRINT  test->MARRIED           FONT "Times-Roman" SIZE 12 ITALIC
   @ F_Mus, 210 HPDFPRINT  test->PHOTO             FONT "Times-Roman" SIZE 12 ITALIC
*------------------------------------------- REF ------------------------------------------*
*----------------------------------------n pagina  ---------------------------------------*

   @ 287, 098 HPDFPRINT "-"+SPACE(3)+ALLTRIM(STR(pagina))+SPACE(3)+"-" FONT "Times-Roman" SIZE 12 ITALIC

*------------------------------------------------------------------------------------------*

          F_Mus=F_Mus+4

           test->(dbskip())

          IF F_Mus > ( 123+140)   // <--------------- Salto de Pgina

             pagina:=pagina+1


       END HPDFPAGE  
*-----------------------------------------------------------------*

      reng:=0

      START HPDFPAGE
     
*--------------------------------------------------- Cuadro General ---------------------------------------------------*

     @ 005,005  HPDFPRINT RECTANGLE TO 292, 206 PENWIDTH 1  ROUNDED CURVE 1         
     @ 007,007  HPDFPRINT RECTANGLE TO 290, 204             ROUNDED CURVE 1       

*----------------------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------------------*

 
*---------------------------------------------------------------------------------------------------------------------------*
   
        F_Mus = 123

        endif
   ENDDO
   


*-------------------------------------------------------------------------------------------------------------------------*

     
         
      END HPDFPAGE  
                
    END HPDFDOC   

*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------*


  Execute file cNombre 

 
RETURN Nil


*-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-*


*------------------------------------------------------------*
  FUNCTION pdf_createQ2()
*------------------------------------------------------------*

  SET DATE FRENCH
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET EPOCH TO 2000

  head2()

   PRIVATE pagina:= 0
   PRIVATE horaS
   PRIVATE reng  := 0
   PRIVATE TOT   := 0.00
   PRIVATE F_Mus := 60   //123       //  <------- Inicio Lnia Facturacin

   PRIVATE FDIA   
   PRIVATE FDIAx  
   PRIVATE HORA  
   PRIVATE HORAx  
   PRIVATE cNombre , cNumero

*-------------------------------------------------------------------------------------*
  FDIA    := DTOC(DATE()) 
  FDIAx   := STRTRAN(FDIA, '/')    && <--------  eliminas la barra(/) 
  HORA    := LEFT(TIME(), 5) 
  HORAx   := STRTRAN(HORA, ':')    && <--------  eliminas los dos puntos(:) 
  cNombre := "Listado_Pdf\" + "Listado" + "_" + FDIAx + '_' + HORAx + '.pdf' 
  cNumero := (  FDIAx  + '_' +  HORAx )

*--------------------------------------------------------------------------------------*

*---------------------------------------------------------------------------------------------*

   SELECT HPDFDOC cNombre TO lSuccess papersize HPDF_PAPER_A4 


*-----------------------------  Cdigo Caracteres ANSI (Latinos) -----------------------------*
*------------------------------ Alternativo es lo Mismo --------------------------------------*

 * SET HPDFDOC ENCODING TO "WinAnsiEncoding"

   SET HPDFDOC ENCODING TO "CP1252"  

*---------------------------------------------------------------------------------------------*

   START HPDFDOC
              
            START HPDFPAGE
		
            pagina:=1

*------------------------------------------------ Cuadro General ------------------------------*

    
     @ 005,005  HPDFPRINT RECTANGLE TO 292, 206 PENWIDTH 1 ROUNDED CURVE 1  
     @ 007,007  HPDFPRINT RECTANGLE TO 290, 204            ROUNDED CURVE 1                  


*----------------------------------------------------------------------------------------------*  
     @ 021,025 HPDFPRINT IMAGE "Resource\Business-Pie.png" width 12 height 12       
     @ 030,055 HPDFPRINT "DataBase WebCam Photo"  FONT "Times-Roman" SIZE 25 ITALIC   
     @ 030,155 HPDFPRINT DTOC(DATE())             FONT "Times-Roman" SIZE 18 ITALIC
     @ 040,015 HPDFPRINT RECTANGLE TO 48, 197  ROUNDED CURVE 1    
     @ 045,026 HPDFPRINT "CODE                                         NAME  "      FONT "Times-Roman" SIZE 9 ITALIC 
     @ 045,127 HPDFPRINT "   PHONE                  DATE                 MARRIED"   FONT "Times-Roman" SIZE 9 ITALIC 

  *------------------------------------------------------------------------*

      select("test")

    DO WHILE !test->(EOF())

        reng=reng+1

*---------------------------------------------------------------------------------------*
*---------------------------------------------------------------------------------------*
   @ F_Mus,  26 HPDFPRINT  STR( test->Code )       FONT "Times-Roman" SIZE 12 ITALIC
   @ F_Mus,  41 HPDFPRINT  ALLTRIM( test->Name )   FONT "Times-Roman" SIZE 12 ITALIC
   @ F_Mus, 125 HPDFPRINT  LTRIM( test->Phone )    FONT "Times-Roman" SIZE 12 ITALIC
   @ F_Mus, 150 HPDFPRINT  DTOC(test->Date )       FONT "Times-Roman" SIZE 12 ITALIC
   @ F_Mus, 180 HPDFPRINT  test->MARRIED           FONT "Times-Roman" SIZE 12 ITALIC
   @ F_Mus, 210 HPDFPRINT  test->PHOTO             FONT "Times-Roman" SIZE 12 ITALIC
*---------------------------------------- REF ------------------------------------------*

 *-------------------------------------n pagina  --------------------------------------*

        @ 287, 098 HPDFPRINT "-"+SPACE(3)+ALLTRIM(STR(pagina))+SPACE(3)+"-" FONT "Times-Roman" SIZE 12 ITALIC

*---------------------------------------------------------------------------------------*

          F_Mus=F_Mus+4

           test->(dbskip())

          IF F_Mus > ( 123+140)   // <--------------- Salto de Pgina

             pagina:=pagina+1


       END HPDFPAGE  

      reng:=0

      START HPDFPAGE
     
*--------------------------------------------------- Cuadro General ---------------------------------------------------*

     @ 005,005  HPDFPRINT RECTANGLE TO 292, 206 PENWIDTH 1  ROUNDED CURVE 1         
     @ 007,007  HPDFPRINT RECTANGLE TO 290, 204             ROUNDED CURVE 1       

*----------------------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------------------*

        F_Mus = 123

        endif
   ENDDO
   
*-------------------------------------------------------------------------------------------------------------------------*

             
      END HPDFPAGE  
                
    END HPDFDOC   

*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------*


  Execute file cNombre 

 
RETURN Nil





*-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-*














